import React, { useEffect, useMemo, useRef, useState } from 'react';
import Taro from '@tarojs/taro';
import { View } from '@tarojs/components';
import { useList } from './hooks';
import { classNames, getRect } from './utils';

export default (props) => {
  const { className, itemClassName, style, gutter = 0, list = [], render, ...leftProps } = props

  const leftBottom = useRef(0)
  const rightBottom = useRef(0)
  const [leftList, leftRef, setLeftList] = useList()
  const [rightList, rightRef, setRightList] = useList()
  const vidRef = useRef()
  const [cursor, setCursor] = useState(-1)

  const listRef = useRef([])
  listRef.current = list
    
  useEffect(() => {
    if (list && list.length) {
      setCursor(0)
      setLeftList([])
      setRightList([])
      console.log('----------useEffect--------')
    } else {
      setCursor(-1)
    }
  }, [list])

  useEffect(() => {
    const len = !listRef.current ? 0 : listRef.current.length;

    if (!len || cursor >= len) return;

    const item = listRef.current[cursor] || {}
    item.__vid = `f-${Math.random().toString(36).substring(2)}`
    vidRef.current = item.__vid

    console.log('----------leftRef.current--------', leftRef.current, rightRef.current)

    if (leftBottom.current <= rightBottom.current) {
      setLeftList([...leftRef.current, item])
    } else {
      setRightList([...rightRef.current, item])
    }
  }, [cursor])

  
  console.log('---------dddddddd------', vidRef.current, leftRef.current.length, leftList)

  useEffect(() => {
    const setHeight = (rect) => {
      console.log('---------rect------', rect)
      const { bottom } = rect
      if (cursor % 2 === 0) {
        leftBottom.current = bottom
      } else {
        rightBottom.current = bottom
      }
      setCursor(cursor + 1)
    }

    const calcHeight = () => {
      getRect(`.${vidRef.current}`).then((res) => {
        if (!res || !res.length) {
          const t = setTimeout(() => {
            clearTimeout(t)
            calcHeight()
          }, 300)
        } else {
          setHeight(res[0])
        }
      })
    }

    calcHeight()
  })

  return (
    <View
      className={classNames(className, 'masonry-layout')}
      style={style}
    >
      <View className='masonry-column'>
        {
          leftList.map((item) => (
            <View key={item.__vid} className={classNames(itemClassName, 'masonry-item', item.__vid)}>{render(item)}</View>
          ))
        }
      </View>
      <View className='masonry-column'>
        {
          rightList.map((item) => (
            <View key={item.__vid} className={classNames(itemClassName, 'masonry-item', item.__vid)}>{render(item)}</View>
          ))
        }
      </View>
    </View>
  )
}
